/**
 * Copyright (c) 2009, Perforce Software, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 * 2.  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE SOFTWARE, INC. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

var t1;
var resizeTimerID = null;
var eventSource = new Timeline.DefaultEventSource(0);
var bandInfos = null;

function onResize() {
    if (resizeTimerID == null) {
 	    resizeTimerID = window.setTimeout(function() {
            resizeTimerID = null;
            tl.layout();
    	}, 500);
    }
}

function onLoad() {
    var theme = Timeline.ClassicTheme.create();
    theme.event.bubble.width = 200;
    theme.event.label.width = 200;
    theme.event.bubble.height = 120;
    bandInfos = [
        Timeline.createBandInfo({
            eventSource: eventSource,
            date: new Date(),
            width: "70%", 
            intervalUnit: Timeline.DateTime.DAY,
            intervalPixels: 100,
            theme: theme
		}),
		Timeline.createBandInfo({
            eventSource: eventSource,
            date: new Date(),
            width: "30%", 
            intervalUnit: Timeline.DateTime.MONTH,
            intervalPixels: 200,
            showEventText: false,
            theme: theme
        })
    ];
    bandInfos[1].syncWith = 0;
    bandInfos[1].highlight = true;
      
    tl = Timeline.create(document.getElementById("timeline"),
            bandInfos, Timeline.HORIZONTAL);
}

function generateTimeline() {
    var text = document.getElementById("path").value;
    tl.loadJSON("timeline?path="+text, function(json, url) {
        eventSource.clear();
        eventSource.loadJSON(json, url);
    });
}